import { NgModule, Component } from '@angular/core';
import { RouterModule, Routes } from '@angular/router';

import {MatButtonToggleModule} from '@angular/material/button-toggle';

import {MatIconModule} from '@angular/material/icon';

import {MatListModule} from '@angular/material/list';
import {MatMenuModule} from '@angular/material/menu';

import {MatSidenavModule} from '@angular/material/sidenav';

import {MatToolbarModule} from '@angular/material/toolbar';

import { AppComponent } from './app.component';


import { NgSelectModule } from '@ng-select/ng-select';
import { FormsModule } from '@angular/forms';

import { ToastrModule } from 'ngx-toastr';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
import {FlexLayoutModule} from "@angular/flex-layout";

import { TuringMachineComponent } from './turing-machine/turing-machine.component';

import { MonacoEditorModule, NgxMonacoEditorConfig } from 'ngx-monaco-editor';

export const routes: Routes = [
 
  {
    path: ':id',
    component: TuringMachineComponent,
  
  },
  {
    path: '',
    pathMatch: "full",
    redirectTo: "0"
  
  },
  { path: '**', redirectTo: '', }
];

export function onMonacoLoadfunc(){
  console.log((<any>window).monaco);
}

@NgModule({
  declarations: [
    AppComponent,
   
   
    TuringMachineComponent

   
  ],
  entryComponents: [],
  imports: [
    FormsModule,
    RouterModule.forRoot(routes),
    NgSelectModule,
    ToastrModule.forRoot(),
    BrowserAnimationsModule,//required for toastr
    FlexLayoutModule,


    // MatAutocompleteModule,
    MatButtonToggleModule,
    MatIconModule,
    MatListModule,
    MatMenuModule,

    MatSidenavModule,
    MatToolbarModule,
    MonacoEditorModule.forRoot({
      baseUrl: 'assets', // configure base path cotaining monaco-editor directory after build default: './assets'
      defaultOptions: { scrollBeyondLastLine: false }, // pass default options to be used
      onMonacoLoad: onMonacoLoadfunc // here monaco object will be available as window.monaco use this function to extend monaco editor functionalities.
    })

  ],
  providers: [],
  bootstrap: [AppComponent]
})
export class AppModule { }
